



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>使用xUnit为.net core程序进行单元测试(中)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">使用xUnit为.net core程序进行单元测试(中)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-18 07:28:16 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>第一部分: <a href="http://www.cnblogs.com/cgzl/p/8283610.html" rel="external nofollow noreferrer">http://www.cnblogs.com/cgzl/p/8283610.html</a></p>
<h1>Assert</h1>
<p>Assert做什么？Assert基于代码的返回值、对象的最终状态、事件是否发生等情况来评估测试的结果。Assert的结果可能是Pass或者Fail。如果所有的asserts都pass了，那么整个测试就pass了；如果有任何assert fail了，那么测试就fail了。</p>
<p>xUnit提供了以下类型的Assert：</p>
<ul><li>boolean：True/False</li>
<li>String：相等/不等，是否为空，以..开始/结束，是否包含子字符串，匹配正则表达式</li>
<li>数值型：相等/不等，是否在某个范围内，浮点的精度</li>
<li>Collection：内容是否相等，是否包含某个元素，是否包含满足某种条件(predicate)的元素，是否所有的元素都满足某个assert</li>
<li>Raised events：Custom events，Framework events(例如：PropertyChanged)</li>
<li>Object Type：是否是某种类型，是否某种类型或继承与某种类型</li></ul>
<h2>一个test里应该有多少个asserts？</h2>
<p>一种建议的做法是，每个test方法里面只有一个assert。</p>
<p>而还有一种建议就是，每个test里面可以有多个asserts，只要这些asserts都是针对同一个行为就行。</p>
<h3>第一个Assert</h3>
<p>目标类：</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">    public class Patient<br />
    {<br />
        public Patient()<br />
        {<br />
            IsNew = true;<br />
        }

        public string FirstName { get; set; }<br />
        public string LastName { get; set; }<br />
        public string FullName =&gt; $"{FirstName} {LastName}";<br />
        public int HeartBeatRate { get; set; }<br />
        public bool IsNew { get; set; }

        public void IncreaseHeartBeatRate()<br />
        {<br />
            HeartBeatRate = CalculateHeartBeatRate() + 2;<br />
        }

        private int CalculateHeartBeatRate()<br />
        {<br />
            var random = new Random();<br />
            return random.Next(1, 100);<br />
        }<br />
    }</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>测试类：</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">    public class PatientShould<br />
    {<br />
        [Fact]<br />
        public void HaveHeartBeatWhenNew()<br />
        {<br />
            var patient = new Patient();

            Assert.True(patient.IsNew);<br />
        }<br />
    }</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>运行测试：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/986268/201801/986268-20180114162446457-1405517055.png" /></p>
<p>结果符合预期，测试通过。</p>
<p>改为Assert.False()的话：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/986268/201801/986268-20180114162501394-1625138434.png" /></p>
<p>测试Fail。</p>
<h3>String Assert</h3>
<p><strong>测试string是否相等</strong>：</p>
<div>
<pre class="prettyprint linenums">        [Fact]<br />
        public void CalculateFullName()<br />
        {<br />
            var p = new Patient<br />
            {<br />
                FirstName = "Nick",<br />
                LastName = "Carter"<br />
            };<br />
            Assert.Equal("Nick Carter", p.FullName);<br />
        }</pre>
</div>
<p>然后你需要Build一下，这样VS Test Explorer才能发现新的test。</p>
<p>运行测试，结果Pass：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/986268/201801/986268-20180114162531832-1298721477.png" /></p>
<p>同样改一下Patient类（别忘了Build一下），让结果失败：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/986268/201801/986268-20180114162555754-1820991949.png" /></p>
<p>从失败信息可以看到期待值和实际值。</p>
<p><strong>StartsWith, EndsWith</strong></p>
<div>
<pre class="prettyprint linenums">        [Fact]<br />
        public void CalculateFullNameStartsWithFirstName()<br />
        {<br />
            var p = new Patient<br />
            {<br />
                FirstName = "Nick",<br />
                LastName = "Carter"<br />
            };<br />
            Assert.StartsWith("Nick", p.FullName);<br />
        }

        [Fact]<br />
        public void CalculateFullNameEndsWithFirstName()<br />
        {<br />
            var p = new Patient<br />
            {<br />
                FirstName = "Nick",<br />
                LastName = "Carter"<br />
            };<br />
            Assert.EndsWith("Carter", p.FullName);e);<br />
        }</pre>
</div>
<p>Build，然后Run Test，结果Pass：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/986268/201801/986268-20180114162627816-352418551.png" /></p>
<p><strong>忽略大小写 ignoreCase</strong>：</p>
<p>string默认的Assert是区分大小写的，这样就会失败：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/986268/201801/986268-20180114162640894-1470561190.png" /></p>
<p>可以为这些方法添加一个参数ignoreCase设置为true，就会忽略大小写：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/986268/201801/986268-20180114162658222-820507212.png" /></p>
<p><strong>包含子字符串 Contains</strong></p>
<div>
<pre class="prettyprint linenums">        [Fact]<br />
        public void CalculateFullNameSubstring()<br />
        {<br />
            var p = new Patient<br />
            {<br />
                FirstName = "Nick",<br />
                LastName = "Carter"<br />
            };<br />
            Assert.Contains("ck Ca", p.FullName);<br />
        }</pre>
</div>
<p>Build，测试结果Pass。</p>
<p><strong>正则表达式，Matches</strong></p>
<p>测试一下First name和Last name的首字母是不是大写的：</p>
<div>
<pre class="prettyprint linenums">        [Fact]<br />
        public void CalculcateFullNameWithTitleCase()<br />
        {<br />
            var p = new Patient<br />
            {<br />
                FirstName = "Nick",<br />
                LastName = "Carter"<br />
            };<br />
            Assert.Matches("[A-Z]{1}{a-z}+ [A-Z]{1}[a-z]+", p.FullName);<br />
        }</pre>
</div>
<p>Build，测试通过。</p>
<h3>数值 Assert</h3>
<p>首先为Patient类添加一个property： BloodSugar。</p>
<div>
<pre class="prettyprint linenums">    public class Patient<br />
    {<br />
        public Patient()<br />
        {<br />
            IsNew = true;<br />
            _bloodSugar = 5.0f;<br />
        }

        private float _bloodSugar;<br />
        public float BloodSugar<br />
        {<br />
            get { return _bloodSugar; }<br />
            set { _bloodSugar = value; }<br />
        }<br />
        ...</pre>
</div>
<p><strong>Equal:</strong></p>
<div>
<pre class="prettyprint linenums">        [Fact]<br />
        public void BloodSugarStartWithDefaultValue()<br />
        {<br />
            var p = new Patient();<br />
            Assert.Equal(5.0, p.BloodSugar);<br />
        }</pre>
</div>
<p>Build，测试通过。</p>
<p><strong>范围， InRange:</strong></p>
<p>首先为Patient类添加一个方法，病人吃饭之后血糖升高：</p>
<div>
<pre class="prettyprint linenums">        public void HaveDinner()<br />
        {<br />
            var random = new Random();<br />
            _bloodSugar += (float)random.Next(1, 1000) / 100; //  应该是1000<br />
        }</pre>
</div>
<p>添加test：</p>
<div>
<pre class="prettyprint linenums">        [Fact]<br />
        public void BloodSugarIncreaseAfterDinner()<br />
        {<br />
            var p = new Patient();<br />
            p.HaveDinner();<br />
            // Assert.InRange&lt;float&gt;(p.BloodSugar, 5, 6);<br />
            Assert.InRange(p.BloodSugar, 5, 6);<br />
        }</pre>
</div>
<p>Build，Run Test，结果Fail：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/986268/201801/986268-20180114162840660-969085560.png" /></p>
<p>可以看到期待的Range和实际的值，这样很好。如果你使用<code>Assert.True(xx &gt;= 5 &amp;&amp; xx &lt;= 6)</code>的话，错误信息只能显示True或者False。</p>
<p>因为HaveDinner方法里，表达式的分母应该是1000，修改后，Build，Run，测试Pass。</p>
<h2>浮点型数值的Assert</h2>
<p>在被测项目添加这两个类:</p>
<div>
<pre class="prettyprint linenums">namespace Hospital<br />
{<br />
    public abstract class Worker<br />
    {<br />
        public string Name { get; set; }

        public abstract double TotalReward { get; }<br />
        public abstract double Hours { get; }<br />
        public double Salary =&gt; TotalReward / Hours;<br />
    }

    public class Plumber : Worker<br />
    {<br />
        public override double TotalReward =&gt; ;<br />
        public override double Hours =&gt; ;<br />
    }<br />
}</pre>
</div>
<p>然后针对Plumber建立一个测试类 PlumberShould.cs, 并建立第一个test:</p>
<div>
<pre class="prettyprint linenums">namespace Hospital.Tests<br />
{<br />
    public class PlumberShould<br />
    {<br />
        [Fact]<br />
        public void HaveCorrectSalary()<br />
        {<br />
            var plumber = new Plumber();<br />
            Assert.Equal(66.666, plumber.Salary);<br />
        }<br />
    }<br />
}</pre>
</div>
<p>Build项目, 然后再Test Explorer里面选择按Class分类显示Tests:</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/986268/201801/986268-20180115120045443-824360602.png" /></p>
<p>Run Selected Test, 结果会失败:</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/986268/201801/986268-20180115120347209-1345321277.png" /></p>
<p>这是一个精度的问题.</p>
<p>在Assert.Equal方法, 可以添加一个precision参数, 设置精度为3:</p>
<div>
<pre class="prettyprint linenums">        [Fact]<br />
        public void HaveCorrectSalary()<br />
        {<br />
            var plumber = new Plumber();<br />
            Assert.Equal(66.666, plumber.Salary, precision: 3);<br />
        }</pre>
</div>
<p>Build, Run Test:</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/986268/201801/986268-20180115120556568-1328163485.png" /></p>
<p>因为有四舍五入的问题, 所以test仍然fail了.</p>
<p>所以还需要改一下:</p>
<div>
<pre class="prettyprint linenums">        [Fact]<br />
        public void HaveCorrectSalary()<br />
        {<br />
            var plumber = new Plumber();<br />
            Assert.Equal(66.66, plumber.Salary, precision: );<br />
        }</pre>
</div>
<p>这次会pass的:</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/986268/201801/986268-20180115120715803-160603039.png" /></p>
<h2>Assert Null值</h2>
<div>
<pre class="prettyprint linenums">        [Fact]<br />
        public void NotHaveNameByDefault()<br />
        {<br />
            var plumber = new Plumber();<br />
            Assert.Null(plumber.Name);<br />
        }

        [Fact]<br />
        public void HaveNameValue()<br />
        {<br />
            var plumber = new Plumber<br />
            {<br />
                Name = "Brian"<br />
            };<br />
            Assert.NotNull(plumber.Name);<br />
        }</pre>
</div>
<p>有两个方法, Assert.Null 和 Assert.NotNull, 直接传入期待即可.</p>
<p>测试会Pass的.</p>
<h2>集合 Collection Assert</h2>
<p>修改一下被测试类, 添加一个集合属性, 并赋值:</p>
<div>
<pre class="prettyprint linenums">namespace Hospital<br />
{<br />
    public abstract class Worker<br />
    {<br />
        public string Name { get; set; }

        public abstract double TotalReward { get; }<br />
        public abstract double Hours { get; }<br />
        public double Salary =&gt; TotalReward / Hours;

        public List&lt;string&gt; Tools { get; set; }<br />
    }

    public class Plumber : Worker<br />
    {<br />
        public Plumber()<br />
        {<br />
            Tools = new List&lt;string&gt;()<br />
            {<br />
                "螺丝刀",<br />
                "扳子",<br />
                "钳子"<br />
            };<br />
        }

        public override double TotalReward =&gt; ;<br />
        public override double Hours =&gt; ;<br />
    }<br />
}</pre>
</div>
<p>测试是否包含某个元素, Assert.Contains():</p>
<div>
<pre class="prettyprint linenums">        [Fact]<br />
        public void HaveScrewdriver()<br />
        {<br />
            var plumber = new Plumber();<br />
            Assert.Contains("螺丝刀", plumber.Tools);<br />
        }</pre>
</div>
<p>Build, Run Test, 结果Pass.</p>
<p>修改一下名字, 让其Fail:</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/986268/201801/986268-20180115122144365-1524505575.png" /></p>
<p>这个失败信息还是很详细的.</p>
<p>相应的还有一个Assert.DoesNotContain()方法, 测试集合是否不包含某个元素.</p>
<div>
<pre class="prettyprint linenums">        [Fact]<br />
        public void NotHaveKeyboard()<br />
        {<br />
            var plumber = new Plumber();<br />
            Assert.DoesNotContain("键盘", plumber.Tools);<br />
        }</pre>
</div>
<p>这个test也会pass.</p>
<p><strong>Predicate:</strong></p>
<p>测试一下集合中是否包含符合某个条件的元素:</p>
<div>
<pre class="prettyprint linenums">        [Fact]<br />
        public void HaveAtLeastOneScrewdriver()<br />
        {<br />
            var plumber = new Plumber();<br />
            Assert.Contains(plumber.Tools, t =&gt; t.Contains("螺丝刀"));<br />
        }</pre>
</div>
<p>使用的是Assert.Contains的一个overload方法, 它的第一个参数是集合, 第二个参数是Predicate.</p>
<p>Build, Run Test, 会Pass的.</p>
<p><strong>比较集合相等:<br /></strong></p>
<p>添加Test:</p>
<div>
<pre class="prettyprint linenums">        [Fact]<br />
        public void HaveAllTools()<br />
        {<br />
            var plumber = new Plumber();<br />
            var expectedTools = new []<br />
            {<br />
                "螺丝刀",<br />
                "扳子",<br />
                "钳子"<br />
            };<br />
            Assert.Equal(expectedTools, plumber.Tools);<br />
        }</pre>
</div>
<p>注意, Plumber的tools类型是List, 这里的expectedTools类型是array.</p>
<p>这个test 仍然会<strong>Pass</strong>.</p>
<p>如果修改一个元素, 那么测试会Fail, 信息如下:</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/986268/201801/986268-20180115123333146-1432758012.png" /></p>
<p><strong>Assert针对集合的每个元素:</strong></p>
<p>如果想对集合的每个元素进行Assert, 当然可以通过循环来Assert了, 但是更好的写法是调用<strong>Assert.All()</strong>方法:</p>
<div>
<pre class="prettyprint linenums">        [Fact]<br />
        public void HaveNoEmptyDefaultTools()<br />
        {<br />
            var plumber = new Plumber();<br />
            Assert.All(plumber.Tools, t =&gt; Assert.False(string.IsNullOrEmpty(t)));<br />
        }</pre>
</div>
<p>这个测试会Pass.</p>
<p>如果在被测试类的Tools属性添加一个空字符串, 那么失败信息会是:</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/986268/201801/986268-20180115123835521-22459213.png" /></p>
<p>这里写到, 4个元素里面有1个没有pass.</p>
<h2>针对Object类型的Assert</h2>
<p>首先再添加一个Programmer类:</p>
<div>
<pre class="prettyprint linenums">    public class Programmer : Worker<br />
    {<br />
        public override double TotalReward =&gt; ;<br />
        public override double Hours =&gt; 3.5;<br />
    }</pre>
</div>
<p>然后建立一个WorkerFactory:</p>
<div>
<pre class="prettyprint linenums">namespace Hospital<br />
{<br />
    public class WorkerFactory<br />
    {<br />
        public Worker Create(string name, bool isProgrammer = false)<br />
        {<br />
            if (isProgrammer)<br />
            {<br />
                return new Programmer { Name = name };<br />
            }<br />
            return new Plumber { Name = name };<br />
        }<br />
    }<br />
}</pre>
</div>
<p><strong>判断是否是某个类型 Assert.IsType&lt;Type&gt;(xx):</strong><br />建立一个测试类 WorkerShould.cs和一个test:</p>
<div>
<pre class="prettyprint linenums">namespace Hospital.Tests<br />
{<br />
    public class WorkerShould<br />
    {<br />
        [Fact]<br />
        public void CreatePlumberByDefault()<br />
        {<br />
            var factory = new WorkerFactory();<br />
            Worker worker = factory.Create("Nick");<br />
            Assert.IsType&lt;Plumber&gt;(worker);<br />
        }<br />
    }<br />
}</pre>
</div>
<p>Build, Run Test: 结果Pass.</p>
<p>相应的, 还有一个<strong>Assert.IsNotType&lt;Type&gt;(xx)</strong>方法.</p>
<p>利用<strong>Assert.IsType&lt;Type&gt;(xx)的返回值</strong>, 它会返回Type(xx的)的这个实例, 添加个一test:</p>
<div>
<pre class="prettyprint linenums">        [Fact]<br />
        public void CreateProgrammerAndCastReturnedType()<br />
        {<br />
            var factory = new WorkerFactory();<br />
            Worker worker = factory.Create("Nick", isProgrammer: true);<br />
            Programmer programmer = Assert.IsType&lt;Programmer&gt;(worker);<br />
            Assert.Equal("Nick", programmer.Name);<br />
        }</pre>
</div>
<p>Build, Run Tests: 结果Pass.</p>
<p><strong>Assert针对父类</strong>:</p>
<p>写这样一个test, 创建的是一个promgrammer, Assert的类型是它的父类Worker:</p>
<div>
<pre class="prettyprint linenums">        [Fact]<br />
        public void CreateProgrammer_AssertAssignableTypes()<br />
        {<br />
            var factory = new WorkerFactory();<br />
            Worker worker = factory.Create("Nick", isProgrammer: true);<br />
            Assert.IsType&lt;Worker&gt;(worker);<br />
        }</pre>
</div>
<p>这个会Fail:</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/986268/201801/986268-20180116120740443-922074453.png" /></p>
<p>这时就应该使用这个方法,&nbsp;<strong>Assert.IsAssignableFrom&lt;祖先类&gt;(xx)</strong>:</p>
<div>
<pre class="prettyprint linenums">        [Fact]<br />
        public void CreateProgrammer_AssertAssignableTypes()<br />
        {<br />
            var factory = new WorkerFactory();<br />
            Worker worker = factory.Create("Nick", isProgrammer: true);<br />
            Assert.<strong>IsAssignableFrom</strong>&lt;<strong>Worker</strong>&gt;(worker);<br />
        }</pre>
</div>
<p>Build, Run Tests: Pass.</p>
<p><strong>Assert针对对象的实例</strong></p>
<p>判断两个引用是否指向不同的实例 <strong>Assert.NotSame(a, b)</strong>:</p>
<div>
<pre class="prettyprint linenums">        [Fact]<br />
        public void CreateSeperateInstances()<br />
        {<br />
            var factory = new WorkerFactory();<br />
            var p1 = factory.Create("Nick");<br />
            var p2 = factory.Create("Nick");<br />
            Assert.NotSame(p1, p2);<br />
        }</pre>
</div>
<p>由工厂创建的两个对象是不同的实例, 所以这个test会Pass.</p>
<p>相应的还有个<strong>Assert.Same(a, b)&nbsp;</strong>方法.</p>
<h1>Assert 异常</h1>
<p>为WorkFactory先添加一个异常处理:</p>
<div>
<pre class="prettyprint linenums">namespace Hospital<br />
{<br />
    public class WorkerFactory<br />
    {<br />
        public Worker Create(string name, bool isProgrammer = false)<br />
        {<br />
            if (name == null)<br />
            {<br />
                throw new ArgumentNullException(nameof(name));<br />
            }<br />
            if (isProgrammer)<br />
            {<br />
                return new Programmer { Name = name };<br />
            }<br />
            return new Plumber { Name = name };<br />
        }<br />
    }<br />
}</pre>
</div>
<p>如果在test执行代码时抛出异常的话, 那么test会直接fail掉.</p>
<p>所以应该使用<strong>Assert.Throws&lt;ArgumentNullException&gt;(...)</strong>方法来Assert是否抛出了特定类型的异常.</p>
<p>添加一个test:</p>
<div>
<pre class="prettyprint linenums">        [Fact]<br />
        public void NotAllowNullName()<br />
        {<br />
            var factory = new WorkerFactory();<br />            // var p = factory.Create(null); // 这个会失败<br />
            Assert.Throws&lt;ArgumentNullException&gt;(() =&gt; factory.Create(null));<br />
        }</pre>
</div>
<p>注意不要直接运行会抛出异常的代码. 应该在Assert.Throws&lt;ET&gt;()的方法里添加lambda表达式来调用方法.</p>
<p>这样的话就会pass.</p>
<p>如果被测试代码没有抛出异常的话, 那么test会fail的. 把抛异常代码注释掉之后再Run:</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/986268/201801/986268-20180116122349037-120118993.png" /></p>
<p>更具体的, 还可以指定参数的名称:</p>
<div>
<pre class="prettyprint linenums">        [Fact]<br />
        public void NotAllowNullName()<br />
        {<br />
            var factory = new WorkerFactory();<br />
            // Assert.Throws&lt;ArgumentNullException&gt;(() =&gt; factory.Create(null));<br />
            Assert.Throws&lt;ArgumentNullException&gt;(<strong>"name"</strong>, () =&gt; factory.Create(null));<br />
        }</pre>
</div>
<p>这里就是说异常里应该有一个叫name的参数.</p>
<p>Run: Pass.</p>
<p>如果把"name"改成"isProgrammer", 那么这个test会fail:</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/986268/201801/986268-20180116122917381-990426166.png" /></p>
<p><strong>利用Assert.Throws&lt;ET&gt;()的返回结果</strong>, 其返回结果就是这个抛出的异常实例.</p>
<div>
<pre class="prettyprint linenums">        [Fact]<br />
        public void NotAllowNullNameAndUseReturnedException()<br />
        {<br />
            var factory = new WorkerFactory();<br />
            <strong>ArgumentNullException ex </strong><strong>= Assert.Throws&lt;ArgumentNullException&gt;(() =&gt; factory.Create(null));<br />
            Assert.Equal("name"</strong><strong>, ex.ParamName);</strong><br />
        }</pre>
</div>
<h1>Assert Events 是否发生(Raised)</h1>
<p>回到之前的Patient类, 添加如下代码:</p>
<div>
<pre class="prettyprint linenums">        public void Sleep()<br />
        {<br />
            OnPatientSlept();<br />
        }

        public event EventHandler&lt;EventArgs&gt; PatientSlept;

        protected virtual void OnPatientSlept()<br />
        {<br />
            PatientSlept?.Invoke(this, EventArgs.Empty);<br />
        }</pre>
</div>
<p>然后回到PatientShould.cs添加test:</p>
<div>
<pre class="prettyprint linenums">        [Fact]<br />
        public void RaiseSleptEvent()<br />
        {<br />
            var p = new Patient();<br />
            Assert.Raises&lt;EventArgs&gt;(<br />
                handler =&gt; p.PatientSlept += handler,<br />
                handler =&gt; p.PatientSlept -= handler,<br />
                () =&gt; p.Sleep());<br />
        }</pre>
</div>
<p><strong>Assert.Raises&lt;T&gt;()</strong>第一个参数是附加handler的Action, 第二个参数是分离handler的Action, 第三个Action是触发event的代码.</p>
<p>Build, Run Test: Pass.</p>
<p>如果注释掉Patient类里Sleep()方法内部那行代码, 那么test会fail:</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/986268/201801/986268-20180116124347099-168195847.png" /></p>
<p><strong>针对INotifyPropertyChanged的特殊Assert</strong>:</p>
<p>修改Patient代码:</p>
<div>
<div>
<pre class="prettyprint linenums">namespace Hospital<br />
{<br />
    public class Patient: INotifyPropertyChanged<br />
    {<br />
        public Patient()<br />
        {<br />
            IsNew = true;<br />
            _bloodSugar = 5.0f;<br />
        }

        public string FirstName { get; set; }<br />
        public string LastName { get; set; }<br />
        public string FullName =&gt; $"{FirstName} {LastName}";<br />
        public int HeartBeatRate { get; set; }<br />
        public bool IsNew { get; set; }

        private float _bloodSugar;<br />
        public float BloodSugar<br />
        {<br />
            get =&gt; _bloodSugar;<br />
            set =&gt; _bloodSugar = value;<br />
        }

        public void HaveDinner()<br />
        {<br />
            var random = new Random();<br />
            _bloodSugar += (float)random.Next(, ) / ;<br />
            OnPropertyChanged(nameof(BloodSugar));<br />
        }

        public void IncreaseHeartBeatRate()<br />
        {<br />
            HeartBeatRate = CalculateHeartBeatRate() + ;<br />
        }

        private int CalculateHeartBeatRate()<br />
        {<br />
            var random = new Random();<br />
            return random.Next(, );<br />
        }

        public void Sleep()<br />
        {<br />
            OnPatientSlept();<br />
        }

        public event EventHandler&lt;EventArgs&gt; PatientSlept;

        protected virtual void OnPatientSlept()<br />
        {<br />
            PatientSlept?.Invoke(this, EventArgs.Empty);<br />
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)<br />
        {<br />
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));<br />
        }<br />
    }<br />
}</pre>
</div>
</div>
<p>添加一个Test:</p>
<div>
<pre class="prettyprint linenums">        [Fact]<br />
        public void RaisePropertyChangedEvent()<br />
        {<br />
            var p = new Patient();<br />
            <strong>Assert.PropertyChanged(p, </strong><strong>"BloodSugar", () =&gt;</strong><strong> p.HaveDinner());<br />
</strong>        }</pre>
</div>
<p>针对INotifyPropertyChanged, 可以使用<strong>Assert.PropertyChanged(..) </strong>这个专用的方法来断定PropertyChanged的Event是否被触发了.</p>
<p>Build, Run Tests: Pass.</p>
<p>到目前为止, 介绍的都是入门级的内容.</p>
<p>接下来要介绍的是稍微进阶一点的内容了.</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/390yr238.html">win7操作系统32位或是64位系统上安装 sql2005 点滴</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qngx7g8.html">JavaScript思维导图&mdash;数据类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q26zwo9.html">LOG4NET日志配置及使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7kgrj9.html">mysql 5&period;7&period;15发布</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vrg1m8.html">SQLServer 索引以及视图</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn12yd38.html">mssql 容易掉进的坑</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okyl719.html">red5下nginx安装配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1lrgx9.html">利用android studio gsonformat插件快速解析复杂json</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn4pmv8.html">4&period;MVC框架开发（母版页的应用、按钮导致的Action处理、从界面向控制器传数据和HtmlHelper控件的实现&lpar;注册的实现&rpar;）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1gkgm9.html">python面对对象编程------4：类基本的特殊方法&lowbar;&lowbar;str&lowbar;&lowbar;&comma;&lowbar;&lowbar;repr&lowbar;&lowbar;&comma;&lowbar;&lowbar;hash&lowbar;&lowbar;&comma;&lowbar;&lowbar;new&lowbar;&lowbar;&comma;&lowbar;&lowbar;bool&lowbar;&lowbar;&comma;6大比较方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge305e8.html">IOS NSArray 倒序</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgylpm8.html">部署statspack工具（二）之解决方案2</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zo1239.html">pandas 对数据帧DataFrame中数据的增删、补全及转换操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk154z8.html">Markdown初入门&lpar;使用Typora编辑&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwj6nv9.html">【全网最全的博客美化系列教程】02&period;添加QQ交谈链接</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o7vrj8.html">POJ1860-Currency Exchange-判正环</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy4n1d9.html">程序运行在&period;Net 4&period;0低版本上 报&OpenCurlyDoubleQuote;System&period;NullReferenceException&rdquo;错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllv4exq.html">Python 进程池</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvz0p38.html">MVCHtmlHelper使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvw12dq.html">第二次项目冲刺（Beta版本）2017&sol;12&sol;6</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8eyx56m9.html">LINUX6安装Oracle10g无法启动安装界面解决</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgw15r8.html">转：java泛型</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2j62mx8.html">IntelliJ Idea 2017 注册码 免费激活方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kd4x49.html">gulp实现公共html代码复用</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mexym0q.html">Asp&period;Net Web API（四）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpdkz79.html">SoapUI模拟REST MockService</a>
			</li>
						<li><a href="https://www.batexi.com/a/950nn768.html">C&num;中MessageBox用法大全（附效果图）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zolx2nq.html">开启tomcat的apr模式，并利用redis做tomcat7的session的共享。</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzxrl08.html">&period;NET使用DAO&period;NET实体类模型操作数据库</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m1n5o8.html">chown 命令详解</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
